/* eslint-disable */
function loadScript(baseUrl) {
  import(`${baseUrl}/gs-worker.js`);
}

var Module;

function _GSPS2PDF(
  dataStruct,
  responseCallback
) {
  // first download the ps data
  var xhr = new XMLHttpRequest();
  let success = true;
  xhr.open("GET", dataStruct.psDataURL);
  xhr.responseType = "arraybuffer";
  xhr.onload = function () {
    // release the URL
    self.URL.revokeObjectURL(dataStruct.psDataURL);
    //set up EMScripten environment
    Module = {
      preRun: [
        function () {
          self.Module.FS.writeFile("input.pdf", new Uint8Array(xhr.response));
        },
      ],
      postRun: [
        function () {
          try {
            if (success) {
            var uarray = self.Module.FS.readFile("output.pdf", { encoding: "binary" });
            var blob = new Blob([uarray], { type: "application/pdf" });
            var pdfDataURL = self.URL.createObjectURL(blob);
            responseCallback(pdfDataURL);
            } else {
                responseCallback(null);
            }
          } catch(e) {
            console.error(e);
            responseCallback(null);
          }
        },
      ],
      locateFile: function (path, prefix) {
        if (path.endsWith(".wasm")) {
          return `${dataStruct.baseUrl}/${path}`;
        }
        return prefix + path;
      },
      arguments: [
        "-sDEVICE=pdfwrite",
        ...(dataStruct.params || []),
        "-DNOPAUSE",
        "-dQUIET",
        "-dBATCH",
        "-sOutputFile=output.pdf",
        "input.pdf",
      ],
      onAbort: function (e) {
        console.error(e);
        responseCallback(null);
      },
      quit: function (status, e) {
          if (status === 0) {
            success = true;
          } else {
            success = false;
            console.error(e);
          }
      },
      print: function (text) {
        console.log(text);
      },
      printErr: function (text) {
        console.error(text);
      },
      totalDependencies: 0,
      noExitRuntime: 1
    };
    // Module.setStatus("Loading Ghostscript...");
    try {
      if (!self.Module) {
        self.Module = Module;
        loadScript(dataStruct.baseUrl);
      } else {
        self.Module["calledRun"] = false;
        self.Module["postRun"] = Module.postRun;
        self.Module["preRun"] = Module.preRun;
          self.Module.callMain();
      }
    } catch(e) {
      console.error(e);
      responseCallback(null);
    }
  };
  xhr.send();
}


self.addEventListener('message', function({data:e}) {
  // console.log("message", e)
  // e.data contains the message sent to the worker.
  if (e.target !== 'wasm'){
    return;
  }
  // console.log('Message received from main script', e.data);
  _GSPS2PDF(e.data, (pdfDataURL) => self.postMessage(pdfDataURL))
});

// console.log("Worker ready")